import { __assign } from "tslib";
import React from "react";
export var withLoader = function (Component, loader) {
    var CachedComponent;
    var LoadedComponent = function (props) {
        var _a, _b, _c, _d, _e, _f;
        var useLoaderArgs = [];
        if (loader.queriesArg) {
            useLoaderArgs.push(loader.queriesArg(props));
        }
        var query = loader.useLoader.apply(loader, useLoaderArgs);
        if (!CachedComponent) {
            CachedComponent = React.forwardRef(Component);
        }
        var onLoading = (_a = loader.onLoading) === null || _a === void 0 ? void 0 : _a.call(loader, props);
        var onError = loader.onError
            ? function (error) {
                if (!loader.onError)
                    return React.createElement(React.Fragment, null);
                return loader.onError(props, error, query);
            }
            : undefined;
        var onSuccess = function (data) { return (React.createElement(CachedComponent, __assign({}, props, { ref: data }))); };
        var whileFetching = loader.whileFetching
            ? {
                prepend: (_c = (_b = loader.whileFetching).prepend) === null || _c === void 0 ? void 0 : _c.call(_b, props, query === null || query === void 0 ? void 0 : query.data),
                append: (_e = (_d = loader.whileFetching).append) === null || _e === void 0 ? void 0 : _e.call(_d, props, query === null || query === void 0 ? void 0 : query.data)
            }
            : undefined;
        var onFetching = (_f = loader === null || loader === void 0 ? void 0 : loader.onFetching) === null || _f === void 0 ? void 0 : _f.call(loader, props, query.data
            ? function () { return onSuccess(query.data); }
            : function () { return React.createElement(React.Fragment, null); });
        var LoaderComponent = loader.LoaderComponent;
        return (React.createElement(LoaderComponent, { onFetching: onFetching, whileFetching: whileFetching, onSuccess: onSuccess, onError: onError, onLoading: onLoading, query: query }));
    };
    return LoadedComponent;
};
//# sourceMappingURL=withLoader.js.map